function game_load()
    map = loader.load("level.tmx")

    firsttime = true
    scaleAmount = 1.5
    allSolidTiles = {}

    shapea = ""
    shapeb = ""

    -- initialize library
    Collider = HC(32, on_collision, collision_stop)
    time = 0
    time2 = 0
    animtime = 0
    animtime2 = 0
    animknife = 1
    sprintTimer = 0
    ztime = 0
    zspawn = 0
    zsound = 0
    sprinting = false
    day = true
    daytime = 0

    fps = 0
    fpsCount = 0
    fpsTime = 0

    --particles
    flashimg = love.graphics.newImage("particle/flash.png")
    flash = love.graphics.newParticleSystem( flashimg, 50 )
    emitterpos = Collider:addPoint(10+28,25)
    flash:setEmissionRate          (50)
    flash:setLifetime              (0.1)
    flash:setParticleLife          (0.2)
    flash:setPosition              (50, 50)
    flash:setDirection             (0)
    flash:setSpread                (1)
    flash:setSpeed                 (50, 100)
    flash:setGravity               (0)
    flash:setRadialAcceleration    (10)
    flash:setTangentialAcceleration(0)
    flash:setSize                  (0.5)
    flash:setSizeVariation         (0.5)
    flash:setRotation              (0)
    flash:setSpin                  (0)
    flash:setSpinVariation         (0)
    flash:stop()

    --add the dude
    dude = love.graphics.newImage("char/dude.png")
    smp = love.graphics.newImage("char/smp.png")
    selImg = love.graphics.newImage("selection/sel.png")
    knife1 = love.graphics.newImage("char/knife_1.png")
    knife2 = love.graphics.newImage("char/knife_2.png")
    knife3 = love.graphics.newImage("char/knife_3.png")
    bulletimg = love.graphics.newImage("particle/bullet.png")

    gunsfx = love.audio.newSource("sfx/rifle.wav", "static")
    lvlsfx = love.audio.newSource("sfx/level_up.wav", "static")
    zombiesfx = {}
    for i = 1, 12, 1 do 
        local zombiemoan = love.audio.newSource("sfx/zombie-"..i..".wav", "static")
        table.insert(zombiesfx, zombiemoan)
    end

    currwep = "smp"
    speedx = 0
    speedy = 0
    health = 100
    healthmax = 100
    stamina = 100
    kills = 0
    exp = 0
    level = 1
    nlvl = 100
    circ = Collider:addRectangle(10, 10, 15, 24)

    --add zombie
    zombieimg = love.graphics.newImage("enemies/zombie.png")
    zombies = {}

    gw, gh = love.graphics.getWidth(), love.graphics.getHeight()
    bullets = {}
    allSolidTiles = findSolidTiles(map)
    math.randomseed(math.random(1,31337))
end

function game_update(dt)
    if health < 0 then 
        for i, z in ipairs(zombies) do
            Collider:remove(z)
            table.remove(zombies, i)
        end
        for i, b in ipairs(bullets) do
            Collider:remove(b)
            table.remove(bullets, i)
        end
        for i, t in ipairs(allSolidTiles) do 
            Collider:remove(t)
            table.remove(bullets, i)
        end
        for i, s in ipairs(zombiesfx) do 
            table.remove(bullets, i)
        end
        Collider:remove(circ)
        Collider:remove(emitterpos)
        gamestate = "intro"
    end
    daytime = daytime + dt
    if daytime > 600 then 
        daytime = 0
        if day == true then 
            day = false
        else
            day = true 
        end
    end

    if exp > nlvl then 
        love.audio.play(lvlsfx)
        exp = 0
        level = level + 1
        nlvl = 100 * level*0.75
        healthmax = healthmax + level*0.75
        health = healthmax
    end

    if love.keyboard.isDown("x") then 
        exp = exp + nlvl
    end

    zspawn = zspawn + dt
    if zspawn > 3 and #zombies < 10 then 
        zspawn = 0
        if #zombies < 10 then 
            spawnzombie(math.random(10,950), math.random(-10,0))
        end
        if #zombies < 10 then 
            spawnzombie(math.random(960,970), math.random(10,710))
        end
        if #zombies < 10 then 
            spawnzombie(math.random(10,950), math.random(720,730))
        end
        if #zombies < 10 then 
            spawnzombie(math.random(-10,0), math.random(10,710))
        end
    end

    if love.keyboard.isDown("lshift") or player.control["sprint"] then
        if love.keyboard.isDown("a")
        or love.keyboard.isDown("w")
        or love.keyboard.isDown("s")
        or love.keyboard.isDown("d") 
        or speedx ~= 0 or speedy ~= 0 then 
            if stamina >= 1 then 
                sprintTimer = sprintTimer + dt 
                if sprintTimer > 0.1 then 
                    sprinting = true
                    stamina = stamina - 1
                    sprintTimer = 0
                end
            end
        else 
            sprinting = false
        end
    else 
        sprinting = false
    end 
    if stamina < 100 and sprinting == false then 
        sprintTimer = sprintTimer + dt 
        if sprintTimer > 0.3 then
            stamina = stamina + 1
            sprintTimer = 0
        end
        if stamina > 100 then 
            stamina = 100
        end 
    end

    target = cam:mousepos()
    x,y = target.x, target.y
    pos = cam:worldCoords(circ:center())
    xc,yc = pos.x, pos.y

    fpsCount = fpsCount+1
    fpsTime = fpsTime + dt
    if fpsTime >= 1 then
        fps = fpsCount
        fpsTime = 0
        fpsCount = 0
    end
    Collider:update(dt)
    zombie_update(dt)
    bullet_update(dt)
    player_update(dt)
    Collider:update(dt)
    scrollCamera()
end

function game_draw()
    cam:attach()
    if day == false then 
        love.graphics.setColor(100+daytime/600*155,100+daytime/600*155,100+daytime/600*155)
    else 
        love.graphics.setColor(255-daytime/600*155,255-daytime/600*155,255-daytime/600*155)
    end
    map:draw()
    --circ:draw("fill")
    xc,yc = circ:center()
    love.graphics.draw(dude, xc, yc, circ:rotation(), 1, 1, 12, 16)
    if currwep == "smp" then
        love.graphics.draw(smp, xc, yc, circ:rotation(), 1, 1, 12, 16)
    elseif currwep == "knife" then 
        if animknife == 1 then 
            love.graphics.draw(knife1, xc, yc, circ:rotation(), 1, 1, 12, 16)
        elseif animknife == 2 then
            love.graphics.draw(knife2, xc, yc, circ:rotation(), 1, 1, 12, 16)
        elseif animknife == 3 then 
            love.graphics.draw(knife3, xc, yc, circ:rotation(), 1, 1, 12, 16)
        end
    end

    for i, z in ipairs(zombies) do
        --z:draw("fill")
        zx, zy = z:center()
        zombAngle = getAngle(zx,zy, xc,yc)
        love.graphics.draw(zombieimg, zx, zy, zombAngle, 1, 1, 9, 16)
    end

    love.graphics.setColor(255,255,255)
    love.graphics.draw(flash, 0, 0)

    for i, b in ipairs(bullets) do
        love.graphics.setColor(0,0,0)
        local bx,by = b:center()
        love.graphics.draw(bulletimg, bx,by, _, 0.7,0.7)
    end
    cam:detach()

    --debuf info
    love.graphics.setColor(255,255,255)
    love.graphics.print("Health:",0,0)
    love.graphics.print(health,45,0)
    love.graphics.print("Stamina:",0,15)
    stamperc = stamina/100
    love.graphics.setColor(0,100,0)
    love.graphics.rectangle("fill", 55,15, 80*stamperc,15)
    love.graphics.rectangle("line", 55,15, 81,16)
    love.graphics.setColor(255,255,255)
    love.graphics.print(stamina,55,15)
    love.graphics.print("FPS:",0,30)
    love.graphics.print(love.timer.getFPS(),27,30)
    love.graphics.print("Kills:",0,45)
    love.graphics.print(kills,27,45)
    love.graphics.print("Time:",0,60)
    love.graphics.print(round(daytime/60, 2),33,60)
    --[[
    for i, t in ipairs(allSolidTiles) do 
        t:draw("fill")
    end
    ]]
    --Experience bar
    pexp = exp/nlvl*100
    love.graphics.setColor(255,225,0)
    love.graphics.rectangle("fill", 0,gh-15,gw*pexp/100,15)
    love.graphics.rectangle("line", 0,gh-16,gw,16)
    love.graphics.setColor(0,0,0)
    love.graphics.print("Level:"..level.."   Experience:"..exp.."/"..nlvl.."("..round(pexp,0).."%)",0,gh-15)
end

function collision_stop(dt, shape_a, shape_b)

end

function on_collision(dt, shape_a, shape_b, mtv_x, mtv_y)
    local z1,z2
    if shape_a.type == "zombie" and shape_b.type == "tile" then
        z1 = shape_a
        z1:move(mtv_x, 0)
        z1:move(0, mtv_y)
    elseif shape_b.type == "zombie" and shape_a.type == "tile" then
        z1 = shape_b
        z1:move(mtv_x, 0)
        z1:move(0, mtv_y)
    elseif shape_a.type == "zombie" and shape_b.type == "zombie" then 
        z1 = shape_a
        z2 = shape_b
        z1:move(mtv_x/2, 0)
        z1:move(0, mtv_y/2)
        z2:move(-mtv_x/2, 0)
        z2:move(0, -mtv_y/2)
    else 
        return
    end
end